<template>
  <div>
    <table class="table table-bordered">
      <thead>
        <tr>
          <th scope="col" v-for="(day, index) in days" :key="index">
            {{ day.long }}
          </th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td
            v-for="(day, dayIndex) in tableData"
            :key="dayIndex"
            class="single-cell"
          >
            <div
              v-if="day[0]"
              @click="changeCellValue(day[0].type, dayIndex, 0)"
              :class="day[0].type"
            >
              {{ day[0].type }}
            </div>
            <div v-else @click="changeCellValue('empty', dayIndex, 0)">
              empty
            </div>
          </td>
        </tr>
        <tr>
          <td
            v-for="(day, dayIndex) in tableData"
            :key="dayIndex"
            class="single-cell"
          >
            <div
              v-if="day[1]"
              @click="changeCellValue(day[1].type, dayIndex, 1)"
              :class="day[1].type"
            >
              {{ day[1].type }}
            </div>
            <div v-else @click="changeCellValue('empty', dayIndex, 1)">
              empty
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>
<script>
export default {
  components: {},
  props: {
    sheduleData: {
      type: Object,
    },
  },
  emits: ["update:shedule"],
  mounted() {
    this.tableData = JSON.parse(JSON.stringify(this.sheduleData));
  },
  data() {
    return {
      days: [
        { short: "Ma", long: "Maandag" },
        { short: "Di", long: "Dinsdag" },
        { short: "Wo", long: "Woensdag" },
        { short: "Do", long: "Donderdag" },
        { short: "Vr", long: "Vrijdag" },
      ],
      options: [
        { name: "/", value: 0 },
        { name: "restafval", value: 1 },
        { name: "PMD", value: 2 },
        { name: "papier", value: 3 },
        { name: "GFT", value: 4 },
        { name: "glas", value: 5 },
      ],
      selectedTypes: {
        Ma: [],
        Di: [],
        Wo: [],
        Do: [],
        Vr: [],
      },
      tableData: [],
    };
  },
  methods: {
    changeCellValue(type, dayIndex, rowIndex) {
      switch (type) {
        case "empty":
          this.tableData[dayIndex][rowIndex] = { type: "restafval" };
          break;
        case "restafval":
          this.tableData[dayIndex][rowIndex].type = "PMD";
          break;
        case "PMD":
          this.tableData[dayIndex][rowIndex].type = "papier";
          break;
        case "papier":
          this.tableData[dayIndex][rowIndex].type = "GFT";
          break;
        case "GFT":
          this.tableData[dayIndex][rowIndex].type = "glas";
          break;
        case "glas":
          this.tableData[dayIndex][rowIndex].type = "empty";
          break;
      }

      this.$emit("update:shedule", this.tableData);
    },
    getTypeStyle(rowIndex, cellIndex) {
      switch (this.tableData[rowIndex][cellIndex]) {
        case 0:
          return "empty";
        case 1:
          return "restafval";
        case 2:
          return "pmd";
        case 3:
          return "papier";
        case 4:
          return "GFT";
        case 5:
          return "glas";
      }
    },
  },
  computed: {
    propShedule() {
      return this.sheduleData;
    },
  },
  watch: {
    propShedule() {
      this.tableData = JSON.parse(JSON.stringify(this.sheduleData));
    },
  },
};
</script>
<style lang="scss" scoped>
@import "../../assets/css/base.css";
@import "../../assets/css/colors.css";
.table {
  background-color: white;
}
th {
  cursor: inherit !important;
}
.single-cell {
  user-select: none;
  cursor: pointer;
  div {
    padding: 0.1rem;
    text-align: center;
  }
}
.restafval {
  background: var(--light-grey);
}
.PMD {
  background: lightblue;
}
.papier {
  background: burlywood;
}
.GFT {
  background: rgb(134, 182, 134);
}
.glas {
  background: rgb(240, 192, 91);
}
</style>
